/*
DHT11 
 
Released under GPLv3.
Please refer to LICENSE file for licensing information.
*/


#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <util/delay.h>

#include "dht11.h"

//#define TEST D,0,H
//#define IMP	{ON(TEST);OFF(TEST);}

uint8_t Dth11Byte[5];
uint8_t FlagDth11, StateDth11, TimeDth11;



void dht11_getdata(void);

 

//     12 
void dht11_getdata(void) {
uint8_t Error=0;

	if (StateDth11==DHT_START){
		StateDth11=DHT_LOWBUS;
		TimeDth11=0;
		OFF(DHT11_PIN);
		DRIVER(DHT11_PIN, OUT);//LOW
//TCCR0B=_BV(CS01);	
		}
	else	
	if (StateDth11==DHT_LOWBUS){
		//if (++TimeDth11>2) // +12    DHT_START 
		if (++TimeDth11>5) // +12    DHT_START 
			StateDth11=DHT_RECEIVE;
		}
		
	if (StateDth11==DHT_RECEIVE){
//IMP;		
		StateDth11=DHT_END;
		memset(Dth11Byte, 0, sizeof(Dth11Byte));

		DRIVER(DHT11_PIN, IN);// 
		//OFF(DHT11_PIN);
		
		_delay_us(10);
		//  
		if( !ACTIVE(DHT11_PIN) ) {//   
			Error=1;
			}
		_delay_us(60);
		if( ACTIVE(DHT11_PIN) ) {//  
			Error=1;
			}

		TCNT0=0;
		while ( !ACTIVE(DHT11_PIN) ){// ,      , 
			if ( TCNT0>TIME_WAIT_US(TIME_RESPONSE) ) {
				Error=1;
				break;
				}
			}

		//   80us    
		TCNT0=0;
		while ( ACTIVE(DHT11_PIN) ){//     
			if ( TCNT0>TIME_WAIT_US(TIME_RESPONSE) ) {
				Error=1;
				break;
				}
			}
		
		// 
		//      
		if (Error==0)
		for(uint8_t j=0; j<5; j++){//byte
			for(uint8_t i=0, b=_BV(7); i<8; i++, b>>=1){//bite
				TCNT0=0;
				while ( !ACTIVE(DHT11_PIN) ){//       50us 
					if ( TCNT0>TIME_WAIT_US(TIME_RESPONSE) ) {
						Error=1;
						break;
						}
					}
				//   50us
				TCNT0=0;
				while ( ACTIVE(DHT11_PIN) ){//    
					if ( TCNT0>TIME_WAIT_US(TIME_RESPONSE) ) {
						Error=1;
						break;
						}
					}
				if (TCNT0>TIME_WAIT_US(40)) Dth11Byte[j]|=b; //else Dth11Byte[j]&=~b; 
				if (Error) break;
				}
			if (Error) break;
			}
		
		if (Error){
			FlagDth11=DHT11_ERROR;
			}
		else{
			FlagDth11=DHT11_OK;
			}
//IMP;		
		}

}





